<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar } from "quasar";

import { checkPermission } from "@/utils/permissions";
import { useRouter } from "vue-router";
import { useTransferDataStore } from "@/modules/05_placement/store";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

/**
 * importType
 */
import type { QTableProps } from "quasar";
import type { officerType } from "@/modules/05_placement/interface/response/officer";

/**
 * importComponents
 */
import Dialogbody from "@/modules/05_placement/components/Help-Government/DialogOrders.vue";

const $q = useQuasar();
const router = useRouter();
const transferStore = useTransferDataStore();
const { statusText } = transferStore;
const mixin = useCounterMixin();
const {
  date2Thai,
  messageError,
  showLoader,
  hideLoader,
  success,
  dialogRemove,
  findOrgNameOld,
  findPosMasterNoOld,
} = mixin;

/**
 * Table
 */
const modal = ref<boolean>(false); //แสดง popup ส่งไปออกคำสั่งช่วยราชการ;

const filterKeyword = ref<string>(""); //คำค้นหารายการช่วยราชการ
const filterKeyword2 = ref<string>(""); //คำค้นหารายการออกคำสั่ง
const rows = ref<officerType[]>([]); //รายการช่วยราชการ
const rows2 = ref<officerType[]>([]); //รายการออกคำสั่ง
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อ-นามสกุล",
    sortable: true,
    field: "name",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return `${row.prefix}${row.firstName} ${row.lastName}`;
    },
  },
  {
    name: "posMasterNoOld",
    align: "left",
    label: "ตำแหน่งเลขที่",
    sortable: true,
    field: "posMasterNoOld",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return findPosMasterNoOld(row);
    },
  },
  {
    name: "positionOld",
    align: "left",
    label: "ตำแหน่งในสายงาน",
    sortable: true,
    field: "positionOld",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "positionLevel",
    align: "left",
    label: "ประเภทตำแหน่ง",
    sortable: true,
    field: "positionLevel",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      let name = "";
      if (row.posTypeNameOld && row.posLevelNameOld) {
        name = `${row.posTypeNameOld} (${row.posLevelNameOld})`;
      } else if (row.posTypeNameOld) {
        name = `${row.posTypeNameOld}`;
      } else if (row.posLevelNameOld) {
        name = `(${row.posLevelNameOld})`;
      } else name = "-";
      return name;
    },
  },
  {
    name: "organizationPositionOld",
    align: "left",
    label: "สังกัด",
    sortable: true,
    field: "organization",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val, row) => findOrgNameOld(row),
  },
  {
    name: "organization",
    align: "left",
    label: "หน่วยงานที่ให้ช่วยราชการ",
    sortable: true,
    field: "organization",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "dateStart",
    align: "left",
    label: "วันเริ่มช่วยราชการ",
    sortable: true,
    field: "dateStart",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val) => date2Thai(val),
  },
  {
    name: "dateEnd",
    align: "left",
    label: "วันสิ้นสุดการช่วยราชการ",
    sortable: true,
    field: "dateEnd",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val) => date2Thai(val),
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่ดำเนินการ",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val) => date2Thai(val),
  },
  {
    name: "status",
    align: "left",
    label: "สถานะ",
    sortable: true,
    field: "status",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val) => statusText(val),
  },
]);
const visibleColumns = ref<string[]>([
  "no",
  "name",
  "posMasterNoOld",
  "positionOld",
  "positionLevel",
  "organizationPositionOld",
  "organization",
  "dateStart",
  "dateEnd",
  "createdAt",
  "status",
]);

/**
 * fetch รายการช่วยราชการ
 */
async function getData() {
  showLoader();
  await http
    .get(config.API.officerMain())
    .then(async (res) => {
      const data = await res.data.result;
      rows.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ยืนยันการลบรายการช่วยราชการ
 * @param id รายการที่ต้องการลบ
 */
function clickDelete(id: string) {
  dialogRemove($q, () => {
    showLoader();
    http
      .delete(config.API.officerMainDelete(id))
      .then(async () => {
        await getData();
        await success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * rediarect หน้ารายละเอียดข้อมูล
 * @param id รายการช่วยราชการที่ต้องการดูรายละเอียด
 */
function openDetail(id: string) {
  router.push(`/placement/help-government/detail/${id}`);
}

/**
 * เปิด popup ส่งไปออกคำสั่งช่วยราชการ
 */
function openModalOrder() {
  const row = rows.value.filter(
    (item: officerType) =>
      (item.status == "WAITTING" ||
        item.status == "PENDING" ||
        item.status == "APPROVE") &&
      item.organizationPositionOld &&
      item.organization &&
      item.dateStart &&
      item.dateEnd
  );
  rows2.value = row;
  modal.value = true;
}

/**
 * ปิด popup ส่งไปออกคำสั่งช่วยราชการ
 */
function closeModal() {
  modal.value = false;
  filterKeyword2.value = "";
}

/**
 * รีเซ็ตข้อมูลในช่องฟิลเตอร์
 */
function resetFilter() {
  filterKeyword.value = "";
  filterKeyword2.value = "";
}

/**
 * ทำงานเมื่อมีการเรียกใช้ Components
 */
onMounted(() => {
  getData();
});
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">รายการช่วยราชการ</div>
  <q-card flat bordered class="col-12 q-mt-sm">
    <div class="row q-pa-md">
      <div class="col-12">
        <div class="row col-12">
          <q-btn
            v-if="checkPermission($route)?.attrIsUpdate"
            @click="openModalOrder"
            size="14px"
            flat
            round
            color="add"
            icon="mdi-account-arrow-right"
          >
            <q-tooltip>ส่งไปออกคำสั่งช่วยราชการ</q-tooltip>
          </q-btn>
          <q-space />
          <q-input
            class="col-xs-12 col-sm-3 col-md-2"
            standout
            dense
            v-model="filterKeyword"
            ref="filterRef"
            outlined
            debounce="300"
            placeholder="ค้นหา"
          >
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>

          <q-select
            v-model="visibleColumns"
            multiple
            outlined
            dense
            options-dense
            :display-value="$q.lang.table.columns"
            emit-value
            map-options
            :options="columns"
            option-value="name"
            style="min-width: 140px"
            class="col-xs-12 col-sm-3 col-md-2 q-ml-sm"
          />
        </div>

        <div class="col-12 q-pt-sm">
          <d-table
            :columns="columns"
            :rows="rows"
            :filter="filterKeyword"
            row-key="id"
            :visible-columns="visibleColumns"
          >
            <template v-slot:header="props">
              <q-tr :props="props">
                <q-th auto-width />
                <q-th v-for="col in props.cols" :key="col.name" :props="props">
                  <span class="text-weight-medium">{{ col.label }}</span>
                </q-th>
              </q-tr>
            </template>
            <template v-slot:body="props">
              <q-tr :props="props">
                <q-td auto-width>
                  <q-btn
                    v-if="checkPermission($route)?.attrIsGet"
                    flat
                    dense
                    round
                    color="info"
                    icon="mdi-eye"
                    @click.stop.prevent="openDetail(props.row.id)"
                  >
                    <q-tooltip>รายละเอียด</q-tooltip>
                  </q-btn>

                  <q-btn
                    v-if="checkPermission($route)?.attrIsDelete"
                    :disable="
                      props.row.status === 'REPORT' ||
                      props.row.status === 'DONE'
                    "
                    icon="delete"
                    flat
                    round
                    dense
                    :color="
                      props.row.status === 'REPORT' ||
                      props.row.status === 'DONE'
                        ? 'grey-5'
                        : 'red'
                    "
                    @click.stop.prevent="clickDelete(props.row.id)"
                  >
                    <q-tooltip>ลบข้อมูล</q-tooltip>
                  </q-btn>
                </q-td>
                <q-td v-for="col in props.cols" :key="col.id">
                  <div v-if="col.name === 'no'">
                    {{ props.rowIndex + 1 }}
                  </div>

                  <div
                    v-else
                    :class="
                      col.name === 'organizationPositionOld' ||
                      col.name === 'organization'
                        ? 'table_ellipsis'
                        : ''
                    "
                  >
                    {{
                      col.value == null ? "" : col.value == "" ? "-" : col.value
                    }}
                  </div>
                </q-td>
              </q-tr>
            </template>
          </d-table>
        </div>
      </div>
    </div>
  </q-card>

  <Dialogbody
    v-model:Modal="modal"
    v-model:filter-keyword2="filterKeyword2"
    :get-data="getData"
    :close-modal="closeModal"
    :rows2="rows2"
  />
</template>
<style scoped lang="scss"></style>
